# 如何提交题解

## 提交内容

提交内容需要包含至少：

- 包含英文题解或者中文题解的一个 README。（当然可以两者都提供）
- 将的题解添加到项目主页的 README 中的对应位置，并添加 🆕 标志
  > 对应位置指的是按照难度和题目序号排列在合适位置

## 关于题解格式要求

至少包含以下几项：

1.  题目地址（518. 零钱兑换 II）

> （518. 零钱兑换 II） 替换成你自己的题目序号和名称

2.  题目描述
3.  思路
4.  关键点
5.  代码

可选项：

1. 扩展
2. 相关题目
3. 参考

读者可根据实际情况添加别的，但是一定不要有雷同出现。 比如增加“想法”这种标签，这个和思路是差不多的意思，为了一致性，请改为思路。

## 代码要求

对于代码部分，要写清楚自己的是什么代码。 比如 Python，Java，C++等。 并且代码块需要显式设置代码格式。 比如 ：

C++ Code：

```c++


```

Python Code：

```python


```

JavaScript Code：

```js
```

Java Code：

```js
```

如何你提供了多种语言实现，那么需要在著名你使用了什么代码。 参考 https://github.com/azl397985856/leetcode/blob/master/problems/78.subsets.md

## 注意点

- 对于中文题解，请提供力扣中国的链接和题目描述。
- 对于英文题解，请提供力扣中国的链接和题目描述。
- 对于复杂的题目需要提供图片描述

## Demo

- [518.coin-change-2（中文题解）](https://github.com/azl397985856/leetcode/blob/master/problems/518.coin-change-2.md)
- [23.merge-k-sorted-lists（中文题解）](https://github.com/azl397985856/leetcode/blob/master/problems/23.merge-k-sorted-lists.md)

- [25.reverse-nodes-in-k-groups-en（英文题解）](https://github.com/azl397985856/leetcode/blob/master/problems/25.reverse-nodes-in-k-groups-en.md)
